/* 
   HtGL

Util type: Apache Admin from Glftpd shell.
Release Date: 2007-12-26
Disks: 01
Requirements: unix/gcc and glftpd

Title: HTGL 0.72

** IMP Notes **

Use this command line for compile: gcc -lcrypt -lcrypto -o htgl htgl.c
Then copy your "/lib/libcrypt.so.1" and "/lib/crypto.so.0"
to jail "/glfptd/lib" .

Maybe you have to use Htgl as glftpd user, since it require to write
in passwd file and other stuff. If you know better tricks no probs.

Set also your LUMBER var, where the scripts will move deleted user dir.
(es: /site/lumber_dir ).

Define or undefine GL2 if you use/unuse GlFTPd 2.0X

-

Info:
- Htgl 0.72  -
Fixed password generator for GlFTPd 1.32
Some fixes in check routine
Added BETA support for GlFTPd 2.0X user passwd

- HtGL 0.6c -
The version in production state on my private/public server, it has
some bug fixes and others checks to work correctly.

Be sure to set your AHT and NEWHT vars.

- HtGL 0.6a -
This version comes with some bug fixes, and without systems calls.
The usefull thing is that now htgl adds the user and password to
glftpd, and can also remove it.
Remember, after you type all your commands, enter always:
site purge

I will start to use it every day on a web_site, then if I will find
some bugs, I will correct 0.6a version. Now, this version is very
manual tested, so you can use with out big problems. (I hope :D).

-

New Command:
site htgl plusdom newdomain.no user xxx1 dir dir_1

Yo can add (if checks are ok) a new virtualhost based on a valid user
folder, of course you can delete it without erasing the user (he could
have a virtualhost elsewhere).

-

Help:

To Set a new domain : htgl newdom 'name_site.dom' user 'name' pw 'password'
To Add a new alias Name: htgl addals 'new_alias.com' base 'old_domain.com'
To Setup User HomeDir: htgl set 'username'
To Add a new redirect: htgl redirect 'site.com' to 'another.site.com'
To delete a site: htgl deldom 'site.com' user 'username'
To delete an Alias Hostname: htgl delali 'alias.xx'
To Add New domain on folder user: htgl plusdom 'name_site.dom' user 'name' dir 'dir_xxx'
To delete a Plus Domain: htgl delplus domain

-

Old History (obsolete with 0.6a?):

When I tested the script I created an user with
flag +1, and I changed his uid in passwd file so
he can sets ownership to new dir's users.
Be sure your 'site' dir has correct permissions
for the sysop user.
The program, write a new httpd.conf file in /
dir, then in the night or when you want, you can
copy the new file in /usr/local/apache/conf/ dir
and restart the httpd daemon.
An user or a program on another machine can send
the commands, many times in the day...
If when you launch a command you get only:
'200 Command Successfull' something is going
wrong with permissions to the dirs.

*/

#define _XOPEN_SOURCE
#include <pwd.h>
#include <stdio.h>
#include <sys/stat.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <fcntl.h>

#define GL2

#ifdef GL2
#include <openssl/evp.h>
#include <openssl/sha.h>
#include <openssl/hmac.h>
#endif

/*
   iMPORTANT
   Change user dir with the name of site httpd admin 
*/ 
#define AHT     "site/user/httpd.conf"
#define NEWHT   "site/user/httpd.conf.tmp"
/* END_iMPORTANT */

/* You have to setup its */
#define APACHE  /* set if you want use it */
#define HBASE   "/opt/glftpd/site/" /* Apache DocumentRoot Suffix */
#define BASE    "/" /* you can leave untouched if you run htgl from glftpd console */
#define LUMBER  "repostry/" /* SET here the dir to store old data in 'site' dir */
#define	EMAILD	"admin@neverland.no"

/* DONT CHANGE BELOW */
#define VERSION "HtGL 0.72"
#define MAXLEN	1024
#define	DIZ1	"Configured by HtGL"
#define	MODE	0700
#define	GID	100
#define	UF	"USER Added by Htgl\nGENERAL 0,0 -1 0 0\nLOGINS 2 0 -1 -1\nTIMEFRAME 0 0\nFLAGS 3C\nTAGLINE No Tagline Set\nDIR /\nCREDITS 14799\nRATIO 0\nALLUP 1 0 1\nALLDN 1 11 1\nWKUP 8 90 12\nWKDN 1 11 1\nDAYUP 12 120 16\nDAYDN 1 11 1\nMONTHUP 2 26 3\nMONTHDN 1 11 1\nNUKE 0 0 0\n"

#define	SHA_SALT_LEN 4

time_t rawtime;
struct tm * timeinfo;
struct  stat st;

void	getword(char *word, char *line, char stop);
void	sethome(char *usert, int modz);
void	gtime(char *times, char *line);
int	check(char *domx, int fg);
void	deldom(char *ddom);
void	zcopy(char *inputName, char *outputName);

struct	stat st; 

char    wbuf[255];
char	user[255];
char	puser[255], tuser[255];
char    buf[MAXLEN];
char	conx[MAXLEN];
char	athd[50], passf[255];
char	nthd[50], *xpasswd;
char	datex[255], localt[255];
char	diz[50];
char	salt[3];
FILE	*cfg, *out;
int	i,i2,func=-1, sd=0,uidnn;
char rndChar[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789./";
char *mon [] = {"Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"};
char *monn [] = {"01","02","03","04","05","06","07","08","09","10","11","12"};

main (argc, argv)
	int	argc;
	char	*argv[];
{
	time(&rawtime);
	timeinfo=localtime(&rawtime);
	sprintf(localt, (char *) asctime(timeinfo));
	for (i2=0;i2<strlen(localt);i2++) if (localt[i2] == '\n') localt[i2] = 0;
	/* printf("NFO stamps: %s\n", localt); */
	gtime(datex, localt);
	/* printf("NFO date %s\n", datex); */

	if (argc==1) {
		func=0;
	} else if (argc>1 && argc<8) {
		if (strcmp(argv[1],"newdom")==0 && strcmp(argv[3],"user")==0 && strcmp(argv[5],"pw")==0) { 
			func=1;
		} else if (strcmp(argv[1],"plusdom")==0 && strcmp(argv[3],"user")==0 && strcmp(argv[5],"dir")==0 && strcmp(argv[6],"\0")!=0) {
			func=7; 
		} else if (strcmp(argv[1],"addals")==0 && strcmp(argv[3],"base")==0 && strcmp(argv[4],"\0")!=0) {
			func=2;
		} else if (strcmp(argv[1],"redirect")==0 && strcmp(argv[3],"to")==0 && strcmp(argv[4],"\0")!=0) {
			func=3;
		} else if (strcmp(argv[1],"set")==0 && strcmp(argv[2],"\0")!=0) {
			printf("4\n");
			func=4; 
		} else if (strcmp(argv[1],"deldom")==0 && strcmp(argv[2],"\0")!=0 && strcmp(argv[3],"user")==0 && strcmp(argv[4],"\0")!=0) {
			func=5;
		} else if (strcmp(argv[1],"delplus")==0 && strcmp(argv[2],"\0")!=0) {
			func=8;
		} else if (strcmp(argv[1],"delali")==0 && strcmp(argv[2],"\0")!=0) { 
			func=6; 
		}
	}
	/*
	printf("Argc: %d\n", argc);
	*/

	if(func>0) {
		sprintf(passf,"%setc/passwd",BASE);
		sprintf(athd,"%s%s",BASE,AHT);
		sprintf(nthd,"%s%s",BASE,NEWHT);
		if (strcmp(argv[4],"\0")!=0) {
			sprintf(user,argv[4]);
		}
		if ((cfg = fopen(passf, "r")) != NULL) {
			fclose(cfg);
		} else {
			printf("PASSWD file not found. Please adjust your path.\n");
			exit(1);
		}

#ifdef APACHE
		if ((cfg = fopen(athd, "r")) != NULL) {
			fclose(cfg);
		} else {
			printf("HTTPD file not found, adjust your path.\n");
			exit(1);
		}
#endif
		
		/* printf("Function: %d - Nr. Arg: %d - [ %s %s %s]\n", func, argc, argv[2], argv[3], argv[4]); */
		if (func==1) {
			uidnn=check(argv[2], 0);
			if(uidnn) {
				uidnn++;
			} else {
				printf("ERR 001\n");
				exit(1);
			}

#ifdef GL2
			char *crypted;
			crypted=malloc(51);
			if(!crypted) {
				printf("500 unable to alloc enough memory for hash\n");
				exit(1);
			}
			srandom(time(0));
			salt[0] = rndChar[random() % 64];
			salt[1] = rndChar[random() % 32];
			salt[3] = 0;
			pw_encrypt_new((unsigned char *) argv[6], salt, crypted);
			/* printf("NFO %s\n", crypted); */
#else
			/* printf("New uid to use: %d\n", uidnn); */
			srandom(time(0));
			salt[0] = rndChar[random() % 64];
			salt[1] = rndChar[random() % 32];
			salt[3] = 0;

			xpasswd = (char *)crypt(argv[6], salt);
#endif
			/* printf("Adding %s with password %s to passwd file.\n", user, xpasswd); */
			sprintf(puser,"%sftp-data/users/%s", BASE, user);
			if ((cfg = fopen(puser, "w")) != NULL) {
				fprintf(cfg, UF);
				fprintf(cfg, "TIME 0 %d 0 0", timeinfo);
				fprintf(cfg, "SLOTS -1 -1\nIP *@*");
				fflush(cfg);
				fclose(cfg);
			} else {
				printf("Unable to create %s!\n", puser);
				exit(1);
			}
			if ((cfg = fopen(passf, "a")) != NULL) {
#ifdef GL2
				fprintf(cfg, "%s:%s:%d:100:%s:/site/%s:/bin/false\n", user, crypted,uidnn, datex, user);
#else
				fprintf(cfg, "%s:%s:%d:100:%s:/site/%s:/bin/false\n", user, xpasswd,uidnn, datex, user);
#endif
				fflush(cfg);
				fclose(cfg);
			} else {
				printf("Unable to update password file!\n");
				exit(1);
			}
			sethome(argv[4], 1);

#ifdef APACHE
			/* New VirtualHost */
			if ((out = fopen(athd, "a")) != NULL) {
				fprintf(out,"<Virtualhost %s>\n", argv[2]);
				fprintf(out,"  ServerAdmin %s\n", EMAILD);
				fprintf(out,"  ServerName %s\n", argv[2]);
				fprintf(out,"  Documentroot %s%s\n", HBASE, user);
				fprintf(out,"</Virtualhost>\n\n");
				fflush(out); fclose(out);
			} else {
				printf("Error Writing %s.\n", athd);
				exit(1);
			} 
#endif
			printf("%s added\n", argv[2]);
		} else if (func==2) {
			/* ALIAS */
			printf("Adding alias to virtualhost\n");
			sd=0;
			if( (cfg = fopen(athd, "r")) != NULL && (out = fopen(nthd, "w")) != NULL) {
				while (fgets(buf, MAXLEN, cfg) != NULL) {
					if (sd==-1) {
						fprintf(out,buf);
					} else if (sd==0) {
						sprintf(conx,"<Virtualhost %s>\n", argv[4]);
						if(strcmp(conx,buf)==0) {
							printf("Good Domain Exists!\n");
							sd=1;
							fprintf(out,buf);
							conx[strlen(conx)-1]='\0';
							sprintf(conx,"</Virtualhost>\n");
						} else {
							fprintf(out,buf);
						}
					} else if (sd==1) {
						if(strcmp(conx,buf)==0) {
							printf("Ok, Writing Alias\n");
							fprintf(out,"  ServerAlias %s\n", argv[2]);
							fprintf(out,buf);
							sd=-1;
						} else {
							fprintf(out,buf);
						}
					}
				}
				fclose(cfg);
				fflush(out);
				fclose(out);
				buf[strlen(buf)-1]='\0';
				if(rename(nthd, athd)!=0) {
					printf("Error renaming temp httpd file.\n");
					exit(1);
				}
			} else {
				printf("HTTPD Conf (Read/Write) Error.\n");
				exit(1);
			}
		} else if (func==3) {
			/* [[REDIRECT]] */
			printf("Adding a redirect to conf...\n");
			out = fopen(nthd, "w");
			if ((cfg = fopen(athd, "r")) != NULL) {
				out = fopen(nthd, "w");
				while (fgets(buf, MAXLEN, cfg) != NULL) {
					fprintf(out,buf);
				}
				fclose(cfg);
				fprintf(out,"# Virtual Host: %s #\n", argv[2]);
				fprintf(out,"<Virtualhost %s>\n", argv[2]);
				fprintf(out,"  ServerAdmin %s\n", EMAILD);
				fprintf(out,"  ServerName www.%s\n", argv[2]);
				fprintf(out,"  Redirect permanent /index.html http://%s\n", argv[4]);
				fprintf(out,"<Virtualhost>\n\n");
				fclose(out);
				buf[strlen(buf)-1]='\0';
				if(rename(nthd, athd)!=0) {
					printf("Error renaming temp httpd file.\n");
					exit(1);
				}
			} else {
				printf("Unable to open httpd conf file.\n");
				exit(1);
			}
		} else if (func==4) {
			sethome(argv[2],0);
		} else if (func==5) {
			/* [[DELETE]] */
			deldom(argv[2]);
			if(rename(nthd, athd)!=0) {
				printf("Error renaming temp httpd file.\n");
				exit(1);
			}

			/* MOVE DIR */
			sprintf(buf, "%ssite/%s", BASE, user);
			sprintf(conx, "%ssite/%s/%s", BASE, LUMBER, user);
			rename(buf, conx);

			/* SETTING Flags 36 */
			sprintf(puser, "%sftp-data/users/%s", BASE, user);
			sprintf(tuser, "%sftp-data/users/%s.tmp", BASE, user);
			if( (cfg = fopen(puser, "r")) != NULL && (out = fopen(tuser, "w")) != NULL) {
				while (fgets(buf, MAXLEN, cfg) != NULL) {
					strcpy(conx,buf);
					getword(wbuf,buf,' ');
					if(strcmp(wbuf,"FLAGS")==0) {
						fprintf(out, "FLAGS 36\n");
						printf("Flags 36 for %s!\n", user);
					} else {
						fprintf(out,conx);
					}
				}
				fclose(cfg);
				fflush(out);
				fclose(out);
				if(rename(tuser, puser)!=0) {
					printf("Error Movinng Homedir.\n");
					exit(1);
				} else {
					printf("Done. Data User %s moved in lumber-room\n", user);
		 		}
			} else {
				printf("Error renaming user file.\n");
				exit(1);
			}
			/* [[END_DELETE]] */ 
		} else if (func==6) {
#ifdef APACHE
			sd=0;
			printf("Deleting Alias %s...\n", argv[2]);
			if( (cfg = fopen(athd, "r")) != NULL && (out = fopen(nthd, "w")) != NULL) {
				while (fgets(buf, MAXLEN, cfg) != NULL) {
					sprintf(conx,"  ServerAlias %s\n", argv[2]);
					if(strcmp(conx,buf)!=0) {
						fprintf(out,buf);
					} else if (strcmp(conx,buf)==0) {
						sd=1;
						printf("Alias Found. Removing.\n");
					}
				}
				fflush(out);
				fclose(out);
				fclose(cfg);
				if (sd==1) {
					printf("Moving %s to %s\n", nthd, athd);
					if(rename(nthd, athd)!=0) {
						printf("Error renaming temp httpd file.\n");
						exit(1);
					}
				} else if (sd==0) {
					printf("No Aliases found.\n");
				}
			} else {
				printf("HTTPD Conf (Read/Write) Error.\n");
			}
#endif
		} else if (func==7) {
			/* PLUSDOM */
#ifdef APACHE
			int y=check(argv[2], 1);
			if ((out = fopen(athd, "a")) != NULL && y) {
				/* fprintf(out,"# Virtual Host: %s #\n", argv[2]); */
				fprintf(out,"<Virtualhost %s>\n", argv[2]);
				fprintf(out,"  ServerAdmin %s\n", EMAILD);
				fprintf(out,"  ServerName %s\n", argv[2]);
				fprintf(out,"  Documentroot %s%s/%s\n", HBASE, user, argv[6]);
				fprintf(out,"</Virtualhost>\n\n");
				fflush(out); fclose(out);
			} else {
				printf("Error writing %s\n", athd);
				exit(1);
			}
#endif			
		} else if (func==8) {
			/* [DELPLUS] */
			deldom(argv[2]);
			if(rename(nthd, athd)!=0) {
				printf("Error renaming temp httpd file.\n");
				exit(1);
			}
			/* [END_DELPLUS] */
		}
		exit(0);
	} else if (func==0) {
		printf("%s:\n  Please Use:\n      To Set a new domain : htgl newdom 'name_site.dom' user 'name' pw 'password'\n      To Add a new alias Name: htgl addals 'new_alias.com' base 'old_domain.com'\n      To Setup User HomeDir: htgl set 'username'\n      To Add a new redirect: htgl redirect 'site.com' to 'another.site.com'\n      To delete a site: htgl deldom 'site.com' user 'username'\n      To delete an Alias Hostname: htgl delali 'alias.xx'\n      To Add New domain on user's folder: htgl plusdom 'name_site.dom' user 'name' dir 'dir_xxx'\n      To delete a Plus Domain: htgl delplus domain\n", VERSION);
		exit(0);
	} else if (func==-1) {
		printf("Bad Arguments number, use 'site htgl' for help.\n");
		exit(1);
	}
}

int pw_encrypt_new(const unsigned char *pwd, unsigned char *encryp, char *digest)
{
    unsigned char hexconvert[3];
    unsigned char *salt;
    int i;
    unsigned char md[SHA_DIGEST_LENGTH];
    int mdlen = SHA_DIGEST_LENGTH;

    unsigned char real_salt[SHA_SALT_LEN + 1];

    bzero(hexconvert, sizeof(hexconvert));

    salt = encryp;
    salt++;
    for (i = 0; i < SHA_SALT_LEN; i++) {
	hexconvert[0] = (*salt);
	salt++;
	hexconvert[1] = (*salt);
	salt++;
	real_salt[i] = strtol(hexconvert, NULL, 16);
    }

    PKCS5_PBKDF2_HMAC_SHA1(pwd, strlen(pwd), real_salt, SHA_SALT_LEN, 100,
			   mdlen, md);

    *digest = '$';
    digest++;
    for (i = 0; i < SHA_SALT_LEN; i++) {
	sprintf(digest, "%02x", real_salt[i]);
	digest += 2;
    }
    *digest = '$';
    digest++;
    for (i = 0; i < mdlen; i++) {
	sprintf(digest, "%02x", md[i]);
	digest += 2;
    }
    //fix the last /0 !!!
    *digest = '\0';

}

/* GetWord */
void
getword(char *word, char *line, char stop)
{
	int		x = 0,
			y;

	for (x = 0; ((line[x]) && (line[x] != stop)); x++)
	word[x] = line[x];

	word[x] = '\0';
	if (line[x])
		++x;
	y = 0;

	while ((line[y++] = line[x++]));
}

/* SetUser */
void sethome(char *usert, int modz) {
	char    fus[255];
	char	uidx[255];

	printf("Setting an User...\n");
	if(modz==0) {
		cfg = fopen(passf, "r");
		while (fgets(buf, MAXLEN, cfg) != NULL) {
			getword(wbuf,buf,':');
			/* printf("Cheking %s\n", wbuf); */
			if(strcmp(usert,wbuf)==0) {
				sprintf(user,wbuf);
				getword(wbuf,buf,':');
				getword(wbuf,buf,':');
				sprintf(uidx,wbuf);
				printf("User %s found... Pid: %s\n", usert, uidx);
				athd[strlen(athd)-1]='\0';
				sprintf(athd,"%ssite/%s", BASE, usert);
				if (stat(athd, &st) == -1) {
					/* printf("New User needs a dir...\n"); */
					mkdir(athd, MODE);
				}
				chown(athd, atoi(uidx), GID);
				/* file_id.diz */
				sprintf(diz,"%ssite/%s/file_id.diz", BASE,usert);
				printf("Writing: %s\n", diz);
				out = fopen(diz, "w");
				fprintf(out,"%s\n%s %s.\n", DIZ1, __DATE__, __TIME__);
				chown(diz, atoi(uidx), GID);
				fflush(out);
				fclose(out);
			}
		}
	} else if (modz==1) {
		sprintf(fus,"%ssite/%s", BASE, usert);
		if (stat(fus, &st) == -1) {
			mkdir(fus, MODE);
		}
		chown(fus, uidnn, GID);
		sprintf(diz,"%ssite/%s/file_id.diz", BASE,usert);
		printf("Writing: %s\n", diz);
		out = fopen(diz, "w");
		fprintf(out,"%s\n%s %s.\n", DIZ1, __DATE__, __TIME__);
		chown(diz, uidnn, GID);
		fflush(out);
		fclose(out);
	}
}

void gtime(char *times, char *line) {
        int     x=1, t=0, zs=6, h=0, x1=4, t1=-1, y=0, g5, j1=0;
        for(t=0;x<zs;t++) {
                if(line[t]==' ') {
                        x++;
			line[t]='-';
                        /* printf("x:%d - t:%d.\n",x,t); */
                        if(line[t+1]==' ') {
                                /* printf("Double Space, zs:%d - x:%d.\n",zs,x); */
				t++;
                        }
                }
		if (x==1) {
		} else if (x==2) { /* MONTH */
			if (t1>-1 && t1<3) {
				//printf("Adding: %c\n", line[t]);
				times[t1]=line[t];
				t1++;
				if(t1==3) {
					//printf("Changing Month: %s\n", times);
					for(g5=0;g5<=11;g5++) {
						if(strcmp(times,mon[g5])==0) {
#ifdef GL2
							strcpy(times,monn[g5]);
#else
							strcpy(times,mon[g5]);
#endif
							g5=11;
							t1--;
						}
					}
				}
			} else if (t1==-1) {
				t1++;
			}
		} else if (x==3) {
			times[t1]=line[t]; /* DAY */
			t1++;
		} else if (x==5) { /* YEAR */
			if(j1==0) {
				times[t1]=line[t]; t1++;
			} else if(j1==3) { 
				times[t1]=line[t]; t1++; 
			} else if (j1==4) {
				times[t1]=line[t]; t1++;
				x=zs;
			}
			j1++;
			/* times[t1]=line[t]; t1++; */
		/* } else {
			times[t1]=line[t];
			t1++;
			if(t==strlen(line)) x++; */
		}
	}
	if(times[t1-1]==' ') { times[t1]='\0'; times[t1-1]='\0'; }
}

int check(char *domx, int fg) {
	char uidn[255];
#ifdef APACHE
	if( (cfg = fopen(athd, "r")) != NULL) {
		while (fgets(buf, MAXLEN, cfg) != NULL) {
			getword(wbuf,buf,' ');
			if(strcmp(wbuf,"<Virtualhost")==0) {
				getword(wbuf,buf,'>');
				if(strcmp(wbuf,domx)==0) {
					printf("Domain active\n");
					return 0;
				}
			}
		}
		fclose(cfg);
	} else {
		printf("HTTPD conf (read) error\n");
		return 0;
	}
#endif

	/* printf("Domain %s accepted...\n", domx); */

	if( (cfg = fopen(passf, "r")) != NULL) {
		while (fgets(buf, MAXLEN, cfg) != NULL) {
			getword(wbuf,buf,':');
			if(strcmp(wbuf,user)==0) {
				if(fg==1) {
					fg=2;
				} else {
					printf("User already exists!\n");
					return 0;
				}
			}
			getword(wbuf,buf,':'); //PW
			getword(wbuf,buf,':'); //UID
			strcpy(uidn,wbuf);
		}
		fclose(cfg);
		if(fg==1) {
			printf("User not found\n");
			return 0;
		}
	} else {
		printf("Error while reading passwd file\n");
		return 0;
	}
	if(atoi(uidn) < 100) {
		printf("NFO uid reset to 101\n");
		//strcpy(uidn,"101");
		return 101;
	}
	return atoi(uidn);
}

void deldom(char *ddom) {
	printf("Deleting VirtualHost %s\n", ddom);
	sd=0;
	if( (cfg = fopen(athd, "r")) != NULL && (out = fopen(nthd, "w")) != NULL) {
		while (fgets(buf, MAXLEN, cfg) != NULL) {
			if (sd==-1) {
				fprintf(out, buf);
			} else if(sd==0) {
				sprintf(conx,"<Virtualhost %s>\n", ddom);
				/* printf("Comparing: %s - %s", athd, buf); */
				if (strcmp(conx,buf)==0) {
					sprintf(conx,"</Virtualhost>\n");
					sd=1;
				} else {
					fprintf(out, buf);
				}
			} else if (sd==1) {
				if(strcmp(conx,buf)==0) {
					printf("Virtualhost Deleted.\n");
					sd=-1;
				} else {
					sd=1;
				}
			}
		}
		fclose(cfg);
		fflush(out);
		fclose(out);
		if(sd==0) printf("I didn't find any domain. %s not Deleted.", ddom);
		sd=0;
	} else {
		printf("HTTPD Conf (Read/Write) Error.\n");
		exit(1);
	}
}

/* ZCOPY */
void zcopy(char *inputName, char *outputName) {
	int     input,output,n;
	char    b[512];

	input = open(inputName,O_RDONLY);
		if (input<0) {perror(inputName); exit(1);}
	output = open(outputName,O_WRONLY|O_CREAT,MODE);
		if (output<0) {perror(outputName); exit(1);}
	while ((n=read(input,b,sizeof b))>0)
		write(output,b,n);
	close(input); close(output);
}

/* EOF */
